/*
   Test program for Simple Error Handling sample - 2 ( SErrHnd2.prg )
*/

#include <hmg.ch>

PROCEDURE Main()

   // SET LANGUAGE
   
*  REQUEST HB_LANG_DE;     HB_LANGSELECT( "DE" )

*  REQUEST HB_LANG_ES;     HB_LANGSELECT( "ES" )
   
*  REQUEST HB_LANG_FR;     HB_LANGSELECT( "FR" )
  
*  REQUEST HB_LANG_IT;     HB_LANGSELECT( "IT" )

*  REQUEST HB_LANG_PLWIN;  HB_LANGSELECT( "PLWIN" )

*  REQUEST HB_LANG_PT;     HB_LANGSELECT( "PT" )

*  REQUEST HB_LANG_RUWIN;  HB_LANGSELECT( "RUWIN" )

*  REQUEST HB_LANG_TRWIN;  HB_LANGSELECT( "TRWIN" )

* MsgBox( SET( _SET_LANGUAGE ) )
   
   // Save the old (standard) error handle block and then assign the new (local) error handler
   
   bOldErrHandler := ERRORBLOCK( { | oError | SEHandler( oError  ) } )
   
   lMaintMode  := .T.  // Maintenance Mode

   // This variables are for testing;
   // Since they are un-declared, all of them are PRIVATE class
   cThisWSNam := GETENV( "COMPUTERNAME" )
   aMemVars   := { 1, 2, 3 }            
   cShortSt   := 'a short string'
   cLongStr   := REPLICATE( 'a long string ', 10 )
   cVeryLongStr  := REPLICATE( 'a very long string (more than 256 byte) ', 10 ) // Its name too long than 10 chracter
   cHeader    := "Memory  Variable List "
   xNILValu   := NIL
   nNumer1    := 1
   nNumWDec   := 2.123
   cDigitStr  := "12345"
   dDateOfDay := DATE()
   cTooLongVarName := "cTooLongVarName"
         
   SET CENT ON
   SET DATE GERM
   
   DEFINE WINDOW frmTstSErHnd2 ;
      AT 141 , 434 ;
      WIDTH 678 HEIGHT 581 ;
      TITLE "A simple error handling sample - 2 ";  
      ON INIT OpenTables() ;
      MAIN
      
      ON KEY ESCAPE OF frmTstSErHnd2 ACTION frmTstSErHnd2.release
      
      DEFINE MAIN MENU OF frmTstSErHnd2
         POPUP "File"
            POPUP "Activate Error"
               ITEM "Variable Not Found" ACTION ActivateError( 1 )
               ITEM "File Not Found"     ACTION ActivateError( 2 )
               ITEM "Corrupted Index"    ACTION ActivateError( 3 )
               ITEM "Array Bound"        ACTION ActivateError( 4 )
               ITEM "Type Mismatch"      ACTION ActivateError( 5 )
               ITEM "Missing .dbt"       ACTION ActivateError( 6 )
               ITEM "Not an Array (N)"   ACTION ActivateError( 7 )
               ITEM "Not an Array (C)"   ACTION ActivateError( 8 )
               ITEM "Macro Substitute 1" ACTION ActivateError( 9 )
               ITEM "Macro Substitute 2" ACTION ActivateError( 10 )
               ITEM "Missing Alias"      ACTION ActivateError( 11 )
            END POPUP
            SEPARATOR
            ITEM "Open Tables"        ACTION OpenTables()
            ITEM "Close Tables"       ACTION DBCLOSEALL()            
            SEPARATOR
            ITEM "E&xit" ACTION frmTstSErHnd2.release
         END POPUP
         
         POPUP "?"
            ITEM "About" ACTION MsgBox( "Simple Error Handler - 2", "About" )
         END POPUP
         
      END MENU
      
   END WINDOW // frmTstSErHnd2

   frmTstSErHnd2.Center
   frmTstSErHnd2.Activate

RETURN // TstErrH2.Main()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROCEDURE ActivateError(;                   // Activate an artificial error 
                         nErrorNo )  

   LOCAL nNumeric1,;
         cNumeric2,;
         xNumeric3,;
         nNumeric,;
         cString,;
         cFunction

   DO CASE 
      CASE nErrorNo = 1    // Variable not found error      
         // Referencing an undefined variable for producing RTE 
         MsgBox( xVaribleUnExist ) 
         *
         * This two messages never will be seen.
         *
         * Because "Variable doesn't exists" is a unrecoverable error.
         *
         MsgBox( "That's all !", "End of program" )
      CASE nErrorNo = 2    // Open Error -2 ( File Not Found )
         SELECT TEST
         SET INDEX TO NAME  // NAME.NTX file not found
      CASE nErrorNo = 3     // Open Error -2 ( File Not Found )
         SELECT TEST
         SET INDEX TO CORRUPTED  // CORRUPTED.NTX file not a valid index file
      CASE nErrorNo = 4     // Array Bound Violation
         MsgBox( aMemVars[ 4 ] )  // aMemVars has tree elements
      CASE nErrorNo = 5     // Type mismatch => argument error
         nNumeric1 := 5
         cNumeric2 := "12"
         xNumeric3 := nNumeric1 + cNumeric2 
      CASE nErrorNo = 6     // Attemp open a .dbf missing .dbt
         USE TEST3
      CASE nErrorNo = 7     // Not an array  => argument error
         nNumeric := 1234
         MsgInfo(  nNumeric[ 1 ] ) // nNumeric isn't an array  
      CASE nErrorNo = 8     // Not an array  => argument error
         cString := "abcde"
         MsgInfo(  cString[ 3 ] ) // why not be "c" ?
     CASE nErrorNo = 9     // Macro error - 1
         cString := "abcde"
         MsgInfo(  &cString )   // Variable ( ABCDE ) doesn't exist 
         NOTE this works (not error):       
         *    cString := "abcde"
         *    cStrgName := "cString"
         *    MsgInfo(  &cStrgName )
     CASE nErrorNo = 10     // Macro error - 2
         cFunction := "FUNC1()"
         MsgInfo(  &cFunction. , "any idea ?" )
     CASE nErrorNo = 11     // Alias does not exist
         SELECT MISSING     
   END CASE 
   
RETURN // ActivateError() 

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.
 
PROCEDURE OpenTables() 
 
  USE TEST ALIAS TEST INDEX TEST
  GO 5
  USE TEST2 ALIAS TEST2 INDEX TEST2 NEW
  GO BOTTOM
  SKIP                               // For test Phantom Record
   
RETURN // OpenTables()      
  
*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

